/******************************************
 *                                        *
 *   SMPC SAMPLE PROGRAM Version 0.56a    *
 *                                        *
 *    file : pad.c                        *
 *                                        *
 *  author : s.uchida sega cs h/w r&d     *
 *                                        *
 *    date : 94/11/09                     *
 *					 12/1/94 a.stern
 *                                        *
 ******************************************/
/*added for memcpy*/
#include <string.h>
#include "ssp.h"


/******************************************
 *                                        *
 * GET PORT STAT
 * calles getperipheral
 ******************************************/


void getportstat(void)
{
	Uint8 i,j,k,l,deviceno;

	void getbutton(Uint8);

	devptr = 32;
	deviceno = 0;

	if (oreg[devptr] == 0 | oreg[devptr] == 0xf0 | oreg[devptr] == 0xf1 | oreg[devptr] == 0x16)
	{

	deviceno = getperipheral(0,deviceno);
	devptr++;
	deviceno = getperipheral(1,deviceno);


	for(i = 0; i < PERMAX; i++)
	  getbutton(i);

	}
}



/*----------------------------------------*
 *                                        *
 * GET PERIPHERAL
 * calles get1device
 *                                        *
 -----------------------------------------*/


Uint8 getperipheral(Uint8 portno,Uint8 deviceno)
{
	Uint8 i,loop = 0;


	port[portno].chg = (port[portno].id != oreg[devptr]);


	port[portno].id = oreg[devptr];

	switch(port[portno].id){
		case NODEV:
			loop = 0;
			strcpy(port[portno].name,"UNKNOWN OR NO DEVICE");
			break;
		case DIRECT:
			loop = 1;
			strcpy(port[portno].name,"DIRECT              ");
			break;
		case TAP6P:
			loop = 6;
			strcpy(port[portno].name,"MULTI TERMINAL 6    ");
			break;
		case TAP4P:
			loop = 4;
			strcpy(port[portno].name,"SEGA TAP            ");
			break;
		      case CLK1: case CLK2: case CLK3:
		      case CLK4: case CLK5: case CLK6:
		      case CLK7: case CLK8: case CLK9:
		      case CLKA: case CLKB: case CLKC:
		      case CLKD: case CLKE: case CLKF:
			loop = port[portno].id & 0x0f;
			strcpy(port[portno].name,"CLOCKED SERIAL      ");
			break;
		default:
			strcpy(port[portno].name,"ILLEGAL PORT ID     ");
			loop = 0;
			break;
	}

	for(i = loop; i < PORTMAX; i++)								/* c̃ytF𖢐ڑƂ */
	  device[i + portno * PORTMAX].SaturnID = 0xff;

	for(i = 0;i < loop; i++)									/* ^bṽytFf[^擾 */
		deviceno = get1device(deviceno);

	return deviceno + PORTMAX - loop;
}


/******************************************
 *                                        *
 * get1device
 *                                        *
 ******************************************/


Uint8 get1device(Uint8 d)
{
	Uint8 i = 0;
	Uint8 pad1,pad2;

	devptr++;		/* 	nqdfobt@̃CfbNXi߂ */

	device[d].change = (device[d].SaturnID != oreg[devptr]);	/* ytFhcω */
	device[d].SaturnID = oreg[devptr];

	if(1|device[d].change){		/* hcωĂ΁iÃo[Wł͕Kj */
		while(i < 10){			/* \̂ĈvhcT */
			if(peri[i].SaturnID == device[d].SaturnID){
				strcpy(device[d].name,peri[i].name);
				strcpy(device[d].shortname,peri[i].shortname);
				device[d].connect = (device[d].SaturnID != 0xff);
				break;
			}
			i++;
		}
	}

	if((device[d].SaturnID >= 0xf0) && (device[d].SaturnID <= 0xff)){	/* ΉytFȂ */
		device[d].datamax = 0;
		for(i=0;i<5;i++)
			device[d].data[i] = 0xff;
		return d+1;
	}

	device[d].MDID = 0;
	device[d].datamax = device[d].SaturnID & 7;	/* f[^̃oCg */


	for(i = 0;i<device[d].datamax;i++){			/* f[^擾 */
		devptr++;
		device[d].data[i] = oreg[devptr];
	}

	return d+1;
}

/*----------------------------------------*
 *                                        *
 * getbutton
 *                                        *
 -----------------------------------------*/


void getbutton(Uint8 d)
{
	Uint8 pad1,pad2;

	device[d].lBtn  = device[d].Btn;	/* Õ{^i[ */

	device[d].Btn = device[PERMAX].Btn;	/* xAׂẴ{^𖢉Ƃ݂Ȃ */

	if( device[d].SaturnID == STDPAD  ||
	    device[d].SaturnID == MD3BPAD ||
	    device[d].SaturnID == ALGSTK  ||
	    device[d].SaturnID == STAIR   ||
	    device[d].SaturnID == KEYBRD  ||
	    device[d].SaturnID == MD6BPAD){

		pad1 = device[d].data[0] ^ 0xff;
		pad2 = device[d].data[1] ^ 0xff;

		device[d].Btn.A     = pad1 & A_BTN;
		device[d].Btn.B     = pad1 & B_BTN;
		device[d].Btn.C     = pad1 & C_BTN;
		device[d].Btn.S     = pad1 & START;
		device[d].Btn.X     = pad2 & X_BTN;
		device[d].Btn.Y     = pad2 & Y_BTN;
		device[d].Btn.Z     = pad2 & Z_BTN;
		device[d].Btn.Up    = pad1 & UP;
		device[d].Btn.Down  = pad1 & DOWN;
		device[d].Btn.Left  = pad1 & LEFT;
		device[d].Btn.Right = pad1 & RIGHT;
		device[d].Btn.L     = pad2 & L_BTN;
		device[d].Btn.R     = pad2 & R_BTN;
	} else if(device[d].SaturnID == MOUSE){
		device[d].Btn.ClickL = device[d].data[0] & 0x01;
		device[d].Btn.ClickR = device[d].data[0] & 0x02;
		device[d].Btn.ClickM = device[d].data[0] & 0x04;
		device[d].Btn.S      = device[d].data[0] & 0x08;
	}
}

/****************** END PAD.C ***************************/
