/******************************************
 *                                        *
 *   SMPC SAMPLE PROGRAM Version 0.56a    *
 *                                        *
 *    file : smpcdisp.c                   *
 *                                        *
 *  author : s.uchida sega cs h/w r&d     *
 *                                        *
 *    date : 94/11/09                     *
 *                                        *
 ******************************************/


#include "ssp.h"

static Uint8 bitpat[] = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};

void OregSampler(void);
void oregsmp_sub(void);



/******************************************
 *                                        *
 * rlobXe[^XfBXvC         *
 *                                        *
 ******************************************/


void OregSampler(void)
{
	Uint32 i;
	Uint8 x,y;

	gcls();

	box(0,1,38,18);
	putstr(9,1,"[SMPC STATUS DISPLAY]",WHITE);
	statusline();
	smpcdispsub(2,3);

	x=18;y = 1;
	putstr(x,y+ 2,"STE/RESD",WHITE);
	putstr(x,y+ 3,"YEAR H",WHITE);
	putstr(x,y+ 4,"YEAR L",WHITE);
	putstr(x,y+ 5,"WEEKDAY/MONTH",WHITE);
	putstr(x,y+ 6,"DAY",WHITE);
	putstr(x,y+ 7,"HOUR",WHITE);
	putstr(x,y+ 8,"MINUTE",WHITE);
	putstr(x,y+ 9,"SECOND",WHITE);
	putstr(x,y+10,"CART CODE",WHITE);
	putstr(x,y+11,"AREA CODE",WHITE);
	putstr(x,y+12,"SYSTEM STATUS 1",WHITE);
	putstr(x,y+13,"SYSTEM STATUS 2",WHITE);
	putstr(x,y+14,"SMEM1 DATA",WHITE);
	putstr(x,y+15,"SMEM2 DATA",WHITE);
	putstr(x,y+16,"SMEM3 DATA",WHITE);
	putstr(x,y+17,"SMEM4 DATA",WHITE);


	while(ProgramMode == OREGSMP){
		putstr(17,BORDERLINE,itosh2((i++)/16),WHITE);
		if(i>4095) i = 0;
	}
}



/******************************************
 *                                        *
 * uuNrlobXe[^X\       *
 *                                        *
 ******************************************/


void oregsmp_sub(void)
{
	Uint16 i,j;
	Uint8 x,y;

	smpcdisporeg(5,3);

	for(i = 0; i < PERMAX; i++)
		tomenuchk(i);
}


