/******************************************
 *                                        *
 *   SMPC SAMPLE PROGRAM Version 0.56a    *
 *                                        *
 *    file : spcmd.c                      *
 *                                        *
 *  author : s.uchida sega cs h/w r&d     *
 *                                        *
 *    date : 94/11/09                     *
 *                                        *
 ******************************************/


#include "ssp.h"



/******************************************
 *                                        *
 * SPCMDINIT
 *                                        *
 ******************************************/

void SpCmdInit(void);

void SpCmdInit(void)
{
	Uint8 i,j,k;

	for(i = 0; i < 30; i++)
		for(j = 0; j < 4; j++)
			for(k = 0; k < 16; k++)
				spcmd[i][j][k] = 0;

	for(i = 0; i < PERMAX; i++){
		spcmd[i][SYSCLIP][CMD]  = 0x0009;		/* VXeNbv */
		spcmd[i][SYSCLIP][XC]   = 0x013f;
		spcmd[i][SYSCLIP][YC]   = 0x00ff;

		spcmd[i][USRCLIP][CMD]  = 0x0008;		/* [U[Nbv */
		spcmd[i][USRCLIP][XA]   = 0x0000;
		spcmd[i][USRCLIP][YA]   = 0x0000;
		spcmd[i][USRCLIP][XC]   = 0x013f;
		spcmd[i][USRCLIP][YC]   = 0x00ff;

		spcmd[i][LOCATE][CMD]   = 0x000a;		/* ΍W */
		spcmd[i][LOCATE][XA]    = 0;
		spcmd[i][LOCATE][YA]    = 0;

		spcmd[i][PATTERN][CMD]  = 0x0002;		/* p^[ */
		spcmd[i][PATTERN][MODE] = 0x00a0;
		spcmd[i][PATTERN][COLBANK] = 0x0000;
		spcmd[i][PATTERN][PTNADRS] = 0x2000;
		spcmd[i][PATTERN][CHARSIZ] = 0x0210;
		spcmd[i][PATTERN][XA]    = -8;
		spcmd[i][PATTERN][YA]    = -8;
		spcmd[i][PATTERN][XB]    =  7;
		spcmd[i][PATTERN][YB]    = -8;
		spcmd[i][PATTERN][XC]    =  7;
		spcmd[i][PATTERN][YC]    =  7;
		spcmd[i][PATTERN][XD]    = -8;
		spcmd[i][PATTERN][YD]    =  7;
	}

	spcmd[PERMAX][ENDCMD][CMD] = 0x8000;		/* IR}h */
	memcpy(SPRVRM,spcmd,CMDSIZ);
}

/*****************END SPCMD.C*******************************/
