/******************************************
 *                                        *
 *   SMPC SAMPLE PROGRAM Version 0.56a    *
 *                                        *
 *    file : spdemo                       *
 *                                        *
 *  author : s.uchida sega cs h/w r&d     *
 *                                        *
 *    date : 94/11/09                     *
 *    CIRCLE OF BALLS                     *
 ******************************************/



#include "ssp.h"
#include <math.h>


/******************************************
 *                                        *
 * SPDEMO
 *                                        *
 ******************************************/

void SpDemo(void);

void SpDemo(void)
{
	Uint8 i,r;

	r = 100;

	for(i = 0; i < 12; i++){
		if(radian[i] == 3.14*2) radian[i] = 0;
		radian[i] += 0.02;
		spcmd[i][PATTERN][PTNADRS] = SPBASE;
		spcmd[i][PATTERN][COLBANK] = COLBASE + COLSTEP * (i & 1);
		spcmd[i][LOCATE][XA] = (Uint16)(CENTERX+r*(cos(radian[i])));
		spcmd[i][LOCATE][YA] = (Uint16)(CENTERY+r*(sin(radian[i])));
	}
	spcmd[12][ENDCMD][CMD] = 0x8000;
	memcpy(SPRVRM,spcmd,CMDSIZ);
}
/*****************END SPDEMO (circle of balls)******************/
